import java.util.concurrent.*;
import java.util.concurrent.locks.ReentrantLock;
public class Bank {

	private double[] accounts;
	private ReentrantLock transferlock = new ReentrantLock();
	
	
	/**
	 * 
	 * @param n
	 * @param initialbalance
	 */
	public Bank(int n, double initialbalance)
	{
		accounts = new double[n];
		for(int i=0;i<n;i++)
		{
			accounts[i] = initialbalance;
		}
	}
	
	/**
	 * 
	 * @param from
	 * @param to
	 * @param amount
	 */
	public void transfer(int from, int to, double amount)
	{
		System.out.println(Thread.currentThread());
		
		transferlock.lock();
		accounts[from] -= amount;
		//System.out.println("Transfer money from account "+from+" to account "+to+" amount:"+amount);
		accounts[to] += amount;
		transferlock.unlock();
		//if(getTotalBalance() < 99998)
		 System.out.println("Sum total: "+getTotalBalance());
	}
	
	/**
	 * 
	 * @return
	 */
	public double getTotalBalance()
	{
		double sum = 0;
		for(int i=0;i< accounts.length;i++)
		{
			sum += accounts[i];
		}
		
		return sum;
	}
	
	public int getSize() { return accounts.length;}
}
